
Ruby - Bug #4716

Ripper orders rescue_mod subnodes inconsistently [PATCH]

05/17/2011 08:21 AM - adgar (Michael Edgar)

Status: Closed   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version:    

ruby -v: ruby 1.9.2p188 (2011-03-28 revision

31204) [x86_64-darwin10.7.0]

Backport:  

Description

Depending on whether a rescue_mod node is in an assignment context or not, the parse order differs:

pp Ripper.sexp("a rescue b")

[:program,

[[:rescue_mod,

[:var_ref, [:@ident, "b", [1, 9]]],

[:var_ref, [:@ident, "a", [1, 0]]]]]]

pp Ripper.sexp("x = a rescue b")

[:program,

[[:assign,

[:var_field, [:@ident, "x", [1, 0]]],

[:rescue_mod,

[:var_ref, [:@ident, "a", [1, 4]]],

[:var_ref, [:@ident, "b", [1, 13]]]]]]]

I've attached a patch that fixes the issue - a patch containing tests will soon follow.

Associated revisions

Revision c1d84bfc - 07/06/2011 07:31 PM - nobu (Nobuyoshi Nakada)

parse.y (arg): rescue_mod is in inverse order from other

modifiers.  patched by michael.j.edgar AT dartmouth.edu at

[ruby-core:36248].  fixed #4716.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@32428 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/30/2011 12:54 AM - adgar (Michael Edgar)

Could I get an update on this? Given the potential for a 1.9.3 release, I'd like to see as few Ripper bugs remaining by the time that comes.

#2 - 06/11/2011 04:53 PM - ko1 (Koichi Sasada)

- Status changed from Open to Assigned

- Assignee set to nobu (Nobuyoshi Nakada)

#3 - 07/03/2011 12:18 PM - adgar (Michael Edgar)

I feel this merits inclusion in Ruby 1.9.3. Otherwise, Ripper will have known user-facing bugs for another point release. A patch has been available for

a month and a half, as well. Any chance for an update?

#4 - 07/07/2011 04:31 AM - nobu (Nobuyoshi Nakada)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r32428.

Michael, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

parse.y (arg): rescue_mod is in inverse order from other

modifiers.  patched by michael.j.edgar AT dartmouth.edu at

[ruby-core:36248].  fixed #4716.

Files

rescue_mod.diff 408 Bytes 05/17/2011 adgar (Michael Edgar)
